import {AbstractControl, FormControl, FormGroup, FormGroupDirective, NgForm, ValidationErrors, ValidatorFn} from '@angular/forms';
import {ErrorStateMatcher} from '@angular/material/core';

export class ActivityModalValidator {
  static weekRangeValidator: ValidatorFn = (fg: AbstractControl): ValidationErrors | null => {
    const fromWeek = (fg as FormGroup).get('fromWeek')?.value;
    const toWeek = (fg as FormGroup).get('toWeek')?.value;
    const weekRangeInvalid = fromWeek === null || toWeek === null || +fromWeek > +toWeek;
    return weekRangeInvalid ? { weekRangeInvalid } : null;
  }
}

export class ActivityModalErrorStateMatcher implements ErrorStateMatcher {
  isErrorState(control: FormControl | null, form: FormGroupDirective | NgForm | null): boolean {
    return !!control?.parent?.invalid && control?.touched;
  }
}
