import {
  AllergiesSection,
  DataCard,
  ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod,
  PosNegEnum,
  WeeklyConsumptionDuringPregnancy,
  WorkEnvironmentImpactSectionAllOfMother,
  YesNoEnum,
  WorkEnvironmentImpactSectionAllOfMotherExposureToWorkEnvironmentRisk,
  OverallAssessmentSectionAllOfPrenatalCareAssessment,
  PositiveNegativeDeclinedScreeningWithDateSection,
  ObstetricAssessment,
  SocialServicesPerinatalCareAssessment,
  MidwifeClinicSectionAllOfParentalCraftClassDesired,
  BodyMeasuresSection,
  ExpectedDateOfDeliverySection,
  OverallAssessmentSection,
  AssistedFertilizationSection,
  PreliminaryRiskAssessment,
  FinalRiskAssessment,
  WorkEnvironmentImpactSection,
  ChronicDiseasesSection,
  TobaccoUseAndExposureSection,
  AlcoholDrinkingBehaviorSection,
  DietaryAndExerciseSection,
  SubstanceUseSection,
  VersionedSection,
  HistoryOfPreviousTreatmentWithImpactOnPregnancySection,
  YesNoDateScreeningSection,
  DateValueUnitScreeningSection,
  BirthPlaceSection,
  MidwifeClinicSection,
  PrenatalRiskAssessmentSection,
  FetalRhDAntibodyScreeningSection,
  PositiveNegativeScreeningWithDateSection,
  SocialHistorySection,
  SocialHistorySectionAllOf,
  HealthCareSection,
  PersonName,
  PersonalDataSectionAllOfTemporaryAddress, PersonalDataSectionAllOfNextOfKin
} from '@nspop/gm-web-facade-api';
import {ObjectHelper} from './objectHelper';
import {MaternalRhDAntibodyScreeningSection} from '@nspop/gm-web-facade-api/build/model/maternalRhDAntibodyScreeningSection';
import MaritalOrPartnershipStatusEnum = SocialHistorySectionAllOf.MaritalOrPartnershipStatusEnum;
import LivingConditionsEnum = SocialHistorySection.LivingConditionsEnum;

/**
 * This class is a null-safe convenience wrapper around data-card. Use this to avoid null-pointers in bindings, since
 * angular does not support conditional chaning in ngModel bindings :sadpanda:
 *
 * Hold on to your butts, coz this is going to be a long one!
 */
export class DataCardWrapper {
  constructor(private dataCard: DataCard) {}
  get asDataCard(): DataCard {
    return this.dataCard;
  }

  get lastPeriod(): Date | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.lastPeriod;
  }
  set lastPeriod(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.lastPeriod', date);
  }
  get daysInMensCycleMin(): number | undefined {
    return (this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.menstrualCycle?.min)?.value;
  }
  set daysInMensCycleMin(days: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard,
    'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.menstrualCycle.min.value', days);
  }
  get daysInMensCycleMax(): number | undefined {
    return (this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.menstrualCycle?.max)?.value;
  }
  set daysInMensCycleMax(days: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard,
      'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.menstrualCycle.max.value', days);
  }
  get naegelsDateOfBirth(): Date | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.expectedDateOfDelivery;
  }
  set naegelsDateOfBirth(days: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.expectedDateOfDelivery',
      days
    );
  }
  get expectedDateOfBirthCertainty(): ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod.CertaintyEnum | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.certainty;
  }
  set expectedDateOfBirthCertainty(careLevel:
                                     ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod.CertaintyEnum
                                     | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.certainty', careLevel);
  }
  get expectedDateOfBirthComment(): string | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.remarks;
  }
  set expectedDateOfBirthComment(remarks: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.remarks', remarks);
  }
  get expectedDateOfBirthFromUltrasound(): Date | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromPrenatalUltrasoundScan;
  }
  set expectedDateOfBirthFromUltrasound(remarks: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.expectedDateOfDeliveryFromPrenatalUltrasoundScan', remarks);
  }
  get fetusCount(): number | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.numberOfFetuses;
  }
  set fetusCount(count: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.numberOfFetuses', count);
  }
  get bmiWeight(): number | undefined {
    return this.dataCard?.bodyMeasuresSection?.prenatalBodyWeight?.value;
  }
  set bmiWeight(weight: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection.prenatalBodyWeight.value', weight);
  }
  get bmiHeight(): number | undefined {
    return this.dataCard?.bodyMeasuresSection?.bodyHeight?.value;
  }
  set bmiHeight(height: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection.bodyHeight.value', height);
  }
  get bmi(): number | undefined {
    return this.dataCard?.bodyMeasuresSection?.bodyMassIndex?.value;
  }
  set bmi(bmi: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection.bodyMassIndex.value', bmi);
  }
  get fertilityTreatmentType(): AssistedFertilizationSection.TypeEnum | undefined {
    return this.dataCard?.assistedFertilizationSection?.type;
  }
  set fertilityTreatmentType(type: AssistedFertilizationSection.TypeEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'assistedFertilizationSection.type', type);
  }
  get fertilityTreatmentComment(): string | undefined {
    return this.dataCard?.assistedFertilizationSection?.remarks;
  }
  set fertilityTreatmentComment(remarks: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'assistedFertilizationSection.remarks', remarks);
  }
  get familyHistory(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.familyHistory;
  }
  set familyHistory(history: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.familyHistory', history);
  }
  get consanguinity(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.consanguinity;
  }
  set consanguinity(yes: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.consanguinity', yes);
  }
  get firstTrimesterScanRequested(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.firstTrimesterUltrasoundScanOfFetusRequested;
  }
  set firstTrimesterScanRequested(requested: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.firstTrimesterUltrasoundScanOfFetusRequested', requested);
  }
  get secondTrimesterScanRequested(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.secondTrimesterUltrasoundScanOfFetusRequested;
  }
  set secondTrimesterScanRequested(requested: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.secondTrimesterUltrasoundScanOfFetusRequested', requested);
  }
  get riskAssessmentRequested(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.prenatalRiskAssessmentRequested;
  }
  set riskAssessmentRequested(requested: boolean | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.preliminaryRiskAssessment.prenatalRiskAssessmentRequested',
      requested
    );
  }
  get doubleTestCompleted(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.doubleTestCompleted;
  }
  set doubleTestCompleted(completed: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.doubleTestCompleted', completed);
  }
  get doubleTestDate(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.doubleTestCompletedDate;
  }
  set doubleTestDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.doubleTestCompletedDate', date);
  }
  get mothersJobType(): string | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.jobType;
  }
  set mothersJobType(jobType: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.jobType', jobType);
  }
  get mothersJobHoursPrWeek(): number | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.hoursOfWorkPerWeek;
  }
  set mothersJobHoursPrWeek(hours: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.hoursOfWorkPerWeek', hours);
  }
  get mothersJobExposureTypes(): WorkEnvironmentImpactSectionAllOfMotherExposureToWorkEnvironmentRisk.TypesEnum[] | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.types;
  }
  set mothersJobExposureTypes(types: WorkEnvironmentImpactSectionAllOfMotherExposureToWorkEnvironmentRisk.TypesEnum[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.types', types);
  }
  get mothersJobExposureRemarks(): string | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.remarks;
  }
  set mothersJobExposureRemarks(remarks: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.remarks', remarks);
  }
  get mothersJobExposureStartDate(): Date | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.start;
  }
  set mothersJobExposureStartDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.start', date);
  }
  get mothersJobExposureEndDate(): Date | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.end;
  }
  set mothersJobExposureEndDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.end', date);
  }
  get mothersJobReferredToWorkMedicine(): boolean | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.referredToOccupationalHealthDepartmentForRiskAssessment;
  }
  set mothersJobReferredToWorkMedicine(referred: boolean | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'workEnvironmentImpactSection.mother.referredToOccupationalHealthDepartmentForRiskAssessment',
      referred
    );
  }
  get mothersJobPrenatalSickLeave(): WorkEnvironmentImpactSectionAllOfMother.PrenatalSickLeaveEnum | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.prenatalSickLeave;
  }
  set mothersJobPrenatalSickLeave(leave: WorkEnvironmentImpactSectionAllOfMother.PrenatalSickLeaveEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.prenatalSickLeave', leave);
  }
  get partnersJobType(): string | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.partner?.jobType;
  }
  set partnersJobType(type: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.partner.jobType', type);
  }
  get mothersAllergies(): string | undefined {
    return this.dataCard?.allergiesSection?.allergiesOfMother;
  }
  set mothersAllergies(allergies: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'allergiesSection.allergiesOfMother', allergies);
  }
  get allergicPredispositionOfChild(): AllergiesSection.AllergicPredispositionOfChildEnum | undefined {
    return this.dataCard?.allergiesSection?.allergicPredispositionOfChild;
  }
  set allergicPredispositionOfChild(type: AllergiesSection.AllergicPredispositionOfChildEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'allergiesSection.allergicPredispositionOfChild', type);
  }
  get chronicDiseases(): ChronicDiseasesSection.ConditionsEnum[] | undefined {
    return this.dataCard?.chronicDiseasesSection?.conditions;
  }
  set chronicDiseases(type: ChronicDiseasesSection.ConditionsEnum[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'chronicDiseasesSection.conditions', type);
  }
  get chronicDiseasesComment(): string | undefined {
    return this.dataCard?.chronicDiseasesSection?.comment;
  }
  set chronicDiseasesComment(comment: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'chronicDiseasesSection.comment', comment);
  }
  get realMedicine(): string | undefined {
    return this.dataCard?.medicineSection?.realMedicine;
  }
  set realMedicine(medicine: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'medicineSection.realMedicine', medicine);
  }
  get natureMedicine(): string | undefined {
    return this.dataCard?.medicineSection?.natureMedicine;
  }
  set natureMedicine(medicine: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'medicineSection.natureMedicine', medicine);
  }
  get mfrVaccination(): string | undefined {
    return this.dataCard?.mmrVaccinationSection?.status;
  }
  set mfrVaccination(status: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'mmrVaccinationSection.status', status);
  }
  get previousHistorySection(): HistoryOfPreviousTreatmentWithImpactOnPregnancySection | undefined {
    return this.dataCard?.historyOfPreviousTreatmentWithImpactOnPregnancySection;
  }
  set previousHistorySection(history: HistoryOfPreviousTreatmentWithImpactOnPregnancySection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'historyOfPreviousTreatmentWithImpactOnPregnancySection', history);
  }
  get previousAdmissions(): string | undefined {
    return this.dataCard?.historyOfPreviousTreatmentWithImpactOnPregnancySection?.history;
  }
  set previousAdmissions(admissions: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'historyOfPreviousTreatmentWithImpactOnPregnancySection.history', admissions);
  }
  get usedTobaccoBeforePregnancy(): TobaccoUseAndExposureSection.TobaccoUserEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.tobaccoUser;
  }
  set usedTobaccoBeforePregnancy(usage: TobaccoUseAndExposureSection.TobaccoUserEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.tobaccoUser', usage);
  }
  get tobaccoEndDate(): Date | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.endDate;
  }
  set tobaccoEndDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.endDate', date);
  }
  get tobaccoDuringPregnancy(): YesNoEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.smokeDuringPregnancy;
  }
  set tobaccoDuringPregnancy(usesTobacco: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.smokeDuringPregnancy', usesTobacco);
  }
  get referredToTobaccoStop(): YesNoEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.referredToTobaccoCessationEducation;
  }
  set referredToTobaccoStop(referred: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.referredToTobaccoCessationEducation', referred);
  }
  get exposureToEnvironmentalSmoke(): YesNoEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.exposureToEnvironmentalTobaccoSmoke;
  }
  set exposureToEnvironmentalSmoke(exposed: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.exposureToEnvironmentalTobaccoSmoke', exposed);
  }
  get alcoholBeforePregnancy(): YesNoEnum | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionBeforePregnancy?.consumesAlcohol;
  }
  set alcoholBeforePregnancy(alcohol: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionBeforePregnancy.consumesAlcohol', alcohol);
  }
  get alcoholUnitsPrWeekBeforePregnancy(): number | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionBeforePregnancy?.consumption?.value;
  }
  set alcoholUnitsPrWeekBeforePregnancy(units: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionBeforePregnancy.consumption.value', units);
  }
  get alcoholDuringPregnancy(): YesNoEnum | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.consumesAlcohol;
  }
  set alcoholDuringPregnancy(alcohol: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.consumesAlcohol', alcohol);
  }
  get alcoholUnitsPrWeekDuringPregnancy(): number | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.consumption?.value;
  }
  set alcoholUnitsPrWeekDuringPregnancy(units: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.consumption.value', units);
  }
  get numberOfWeeksWithExcessiveDrinking(): number | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.excessiveDrinkingCount;
  }
  set numberOfWeeksWithExcessiveDrinking(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.excessiveDrinkingCount', value);
  }
  get excessiveDrinkingWeeks(): number[] | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.excessiveDrinkingWeeks;
  }
  set excessiveDrinkingWeeks(value: number[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.excessiveDrinkingWeeks', value);
  }
  get tweakPoints(): WeeklyConsumptionDuringPregnancy.TweakPointsEnum | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.tweakPoints;
  }
  set tweakPoints(value: WeeklyConsumptionDuringPregnancy.TweakPointsEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.tweakPoints', value);
  }
  get substanceUseBeforePregnancy(): YesNoEnum | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.substanceUse;
  }
  set substanceUseBeforePregnancy(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseBeforePregnancy.substanceUse', value);
  }
  get substanceUseBeforePregnancyComment(): string | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.text;
  }
  set substanceUseBeforePregnancyComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseBeforePregnancy.text', value);
  }
  get substanceUseDuringPregnancy(): YesNoEnum | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.substanceUse;
  }
  set substanceUseDuringPregnancy(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseDuringPregnancy.substanceUse', value);
  }
  get substanceUseDuringPregnancyComment(): string | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.text;
  }
  set substanceUseDuringPregnancyComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseDuringPregnancy.text', value);
  }
  get exerciseComment(): string | undefined {
    return this.dataCard?.dietaryAndExerciseSection?.text;
  }
  set exerciseComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'dietaryAndExerciseSection.text', value);
  }
  get hepatititsBSection(): PositiveNegativeDeclinedScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.hepatitisB;
  }
  set hepatititsBSection(value: PositiveNegativeDeclinedScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hepatitisB', value);
  }
  get hepatitisBResult(): PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined {
    return this.dataCard?.screeningsSection?.hepatitisB?.result;
  }
  set hepatitisBResult(value: PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hepatitisB.result', value);
  }
  get hepatitisBDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.hepatitisB?.date;
  }
  set hepatitisBDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hepatitisB.date', value);
  }
  get hivSection(): PositiveNegativeDeclinedScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.hiv;
  }
  set hivSection(value: PositiveNegativeDeclinedScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hiv', value);
  }
  get hivResult(): PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined {
    return this.dataCard?.screeningsSection?.hiv?.result;
  }
  set hivResult(value: PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hiv.result', value);
  }
  get hivDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.hiv?.date;
  }
  set hivDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hiv.date', value);
  }
  get syphilisSection(): PositiveNegativeDeclinedScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.syphilis;
  }
  set syphilisSection(value: PositiveNegativeDeclinedScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.syphilis', value);
  }
  get syphilisResult(): PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined {
    return this.dataCard?.screeningsSection?.syphilis?.result;
  }
  set syphilisResult(value: PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.syphilis.result', value);
  }
  get syphilisDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.syphilis?.date;
  }
  set syphilisDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.syphilis.date', value);
  }
  get chlamydiaSection(): PositiveNegativeDeclinedScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.chlamydia;
  }
  set chlamydiaSection(value: PositiveNegativeDeclinedScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.chlamydia', value);
  }
  get chlamydiaResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.chlamydia?.result;
  }
  set chlamydiaResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.chlamydia.result', value);
  }
  get chlamydiaDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.chlamydia?.date;
  }
  set chlamydiaDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.chlamydia.date', value);
  }
  get gonorrheaSection(): PositiveNegativeDeclinedScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.gonorrhea;
  }
  set gonorrheaSection(value: PositiveNegativeDeclinedScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.gonorrhea', value);
  }
  get gonorrheaResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.gonorrhea?.result;
  }
  set gonorrheaResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.gonorrhea.result', value);
  }
  get gonorrheaDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.gonorrhea?.date;
  }
  set gonorrheaDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.gonorrhea.date', value);
  }
  get hemoglobinopathySection(): PositiveNegativeDeclinedScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.hemoglobinopathy;
  }
  set hemoglobinopathySection(value: PositiveNegativeDeclinedScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hemoglobinopathy', value);
  }
  get hemoglobinopathyResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.hemoglobinopathy?.result;
  }
  set hemoglobinopathyResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hemoglobinopathy.result', value);
  }
  get hemoglobinopathyDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.hemoglobinopathy?.date;
  }
  set hemoglobinopathyDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hemoglobinopathy.date', value);
  }
  get mrsaSwapSection(): YesNoDateScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.mrsaSwap;
  }
  set mrsaSwapSection(value: YesNoDateScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.mrsaSwap', value);
  }
  get mrsaSwapDone(): YesNoEnum | undefined {
    return this.dataCard?.screeningsSection?.mrsaSwap?.value;
  }
  set mrsaSwapDone(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.mrsaSwap.value', value);
  }
  get mrsaSwapDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.mrsaSwap?.date;
  }
  set mrsaSwapDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.mrsaSwap.date', value);
  }
  get vitaminDConsumptionSection(): DateValueUnitScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.vitaminDConsumption;
  }
  set vitaminDConsumptionSection(value: DateValueUnitScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.vitaminDConsumption', value);
  }
  get vitaminDConsumption(): number | undefined {
    return this.dataCard?.screeningsSection?.vitaminDConsumption?.value;
  }
  set vitaminDConsumption(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.vitaminDConsumption.value', value);
  }
  get vitaminDConsumptionDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.vitaminDConsumption?.date;
  }
  set vitaminDConsumptionDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.vitaminDConsumption.date', value);
  }
  get prenatalCareAssessment(): string | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.assessment;
  }
  set prenatalCareAssessment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.assessment', value);
  }
  get generalPractitionerName(): string | undefined {
    return this.dataCard?.personalDataSection?.generalPractitioner?.name;
  }
  set generalPractitionerName(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.generalPractitioner.name', value);
  }
  get careLevel(): OverallAssessmentSectionAllOfPrenatalCareAssessment.CareLevelEnum | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.careLevel;
  }
  set careLevel(value: OverallAssessmentSectionAllOfPrenatalCareAssessment.CareLevelEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.careLevel', value);
  }
  get prenatalCareAssessmentComment(): string | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.comment;
  }
  set prenatalCareAssessmentComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.comment', value);
  }
  get obstetricAssessmentRequired(): YesNoEnum | undefined {
    return this.dataCard?.overallAssessmentSection?.obstetricAssessment?.required;
  }
  set obstetricAssessmentRequired(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.obstetricAssessment.required', value);
  }
  get obstetricAssessmentReason(): string | undefined {
    return (this.dataCard?.overallAssessmentSection?.obstetricAssessment as ObstetricAssessment)?.reason;
  }
  set obstetricAssessmentReason(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.obstetricAssessment.reason', value);
  }
  get socialServicesRequired(): YesNoEnum | undefined {
    return this.dataCard?.overallAssessmentSection?.socialServicesPerinatalCareAssessment?.required;
  }
  set socialServicesRequired(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.socialServicesPerinatalCareAssessment.required', value);
  }
  get socialServicesReason(): string | undefined {
    return (this.dataCard?.overallAssessmentSection?.socialServicesPerinatalCareAssessment as SocialServicesPerinatalCareAssessment)
      ?.reason;
  }
  set socialServicesReason(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.socialServicesPerinatalCareAssessment.reason', value);
  }
  get birthPlaceSection(): BirthPlaceSection | undefined {
    return this.dataCard?.birthPlaceSection;
  }
  set birthPlaceSection(value: BirthPlaceSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection', value);
  }
  get desiredBirthPlace(): string | undefined {
    return this.dataCard?.birthPlaceSection?.desiredBirthPlace;
  }
  set desiredBirthPlace(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection.desiredBirthPlace', value);
  }
  get desiredBirthPlaceLocation(): string | undefined {
    return this.dataCard?.midwifeClinicSection?.midwifeConsultationWishes?.location;
  }
  set desiredBirthPlaceLocation(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.midwifeConsultationWishes.location', value);
  }
  get desiredBirthPlaceNotes(): string | undefined {
    return this.dataCard?.midwifeClinicSection?.midwifeConsultationWishes?.notes;
  }
  set desiredBirthPlaceNotes(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.midwifeConsultationWishes.notes', value);
  }
  get primaryPlannedBirthPlace(): string | undefined {
    return this.dataCard?.birthPlaceSection?.primaryPlannedBirthPlace?.name;
  }
  set primaryPlannedBirthPlace(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection.primaryPlannedBirthPlace.name', value);
  }
  get revisedPlannedBirthPlace(): string | undefined {
    return this.dataCard?.birthPlaceSection?.revisedPlannedBirthPlace?.name;
  }
  set revisedPlannedBirthPlace(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection.revisedPlannedBirthPlace.name', value);
  }
  get midwifeClinicSection(): MidwifeClinicSection | undefined {
    return this.dataCard?.midwifeClinicSection;
  }
  set midwifeClinicSection(value: MidwifeClinicSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection', value);
  }
  get assignedMidwifeClinic(): string | undefined {
    return this.dataCard?.midwifeClinicSection?.assignedMidwifeClinic?.name;
  }
  set assignedMidwifeClinic(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.assignedMidwifeClinic.name', value);
  }
  get parentalCraftClassDesired(): YesNoEnum | undefined {
    return this.dataCard?.midwifeClinicSection?.parentalCraftClassDesired?.parentalCraftClassDesired;
  }
  set parentalCraftClassDesired(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.parentalCraftClassDesired.parentalCraftClassDesired', value);
  }
  get midwifeConsultationForm(): MidwifeClinicSectionAllOfParentalCraftClassDesired.ConsultationFormEnum | undefined {
    return this.dataCard?.midwifeClinicSection?.parentalCraftClassDesired?.consultationForm;
  }
  set midwifeConsultationForm(value: MidwifeClinicSectionAllOfParentalCraftClassDesired.ConsultationFormEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.parentalCraftClassDesired.consultationForm', value);
  }
  get firstTrimesterScan(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.firstTrimesterUltrasoundScanOfFetusCompleted;
  }
  set firstTrimesterScan(value: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.firstTrimesterUltrasoundScanOfFetusCompleted',
      value
    );
  }
  get secondTrimesterScan(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.secondTrimesterUltrasoundScanOfFetusCompleted;
  }
  set secondTrimesterScan(value: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.secondTrimesterUltrasoundScanOfFetusCompleted',
      value
    );
  }
  get downsProbability(): 'high' | 'low' | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.downsScreeningProbabilityAssessment;
  }
  set downsProbability(value: 'high' | 'low' | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.downsScreeningProbabilityAssessment', value);
  }
  get multiplicityRisk(): YesNoEnum | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.multiplicityRiskAssessment?.risk;
  }
  set multiplicityRisk(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.multiplicityRiskAssessment.risk', value);
  }
  get multiplicityRiskComment(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.multiplicityRiskAssessment?.comment;
  }
  set multiplicityRiskComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.multiplicityRiskAssessment.comment', value);
  }
  get placentalBiopsyDate(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.placentalBiopsiObservation?.date;
  }
  set placentalBiopsyDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.placentalBiopsiObservation.date', value);
  }
  get placentalBiopsyResult(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.placentalBiopsiObservation?.result;
  }
  set placentalBiopsyResult(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.placentalBiopsiObservation.result', value);
  }
  get prenatalAmniocentesisDate(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.prenatalAmniocentesisiObservation?.date;
  }
  set prenatalAmniocentesisDate(value: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.prenatalAmniocentesisiObservation.date',
      value
    );
  }
  get prenatalAmniocentesisResult(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.prenatalAmniocentesisiObservation?.result;
  }
  set prenatalAmniocentesisResult(value: string | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.prenatalAmniocentesisiObservation.result',
      value
    );
  }
  get bodyMeasuresSection(): BodyMeasuresSection | undefined {
    return this.dataCard?.bodyMeasuresSection;
  }
  set bodyMeasuresSection(value: BodyMeasuresSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection', value);
  }
  get expectedDateOfDeliverySection(): ExpectedDateOfDeliverySection | undefined {
    return this.dataCard?.expectedDateOfDeliverySection;
  }
  set expectedDateOfDeliverySection(value: ExpectedDateOfDeliverySection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection', value);
  }
  get overallAssessmentSection(): OverallAssessmentSection | undefined {
    return this.dataCard?.overallAssessmentSection;
  }
  set overallAssessmentSection(value: OverallAssessmentSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection', value);
  }
  get assistedFertilizationSection(): AssistedFertilizationSection | undefined {
    return this.dataCard?.assistedFertilizationSection;
  }
  set assistedFertilizationSection(value: AssistedFertilizationSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'assistedFertilizationSection', value);
  }
  get preliminaryRiskAssessment(): PreliminaryRiskAssessment | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment;
  }
  set preliminaryRiskAssessment(value: PreliminaryRiskAssessment | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment', value);
  }
  get finalRiskAssessment(): FinalRiskAssessment | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment;
  }
  set finalRiskAssessment(value: FinalRiskAssessment | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment', value);
  }
  get workEnvironmentImpactSection(): WorkEnvironmentImpactSection | undefined {
    return this.dataCard?.workEnvironmentImpactSection;
  }
  set workEnvironmentImpactSection(value: WorkEnvironmentImpactSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection', value);
  }
  get allergiesSection(): AllergiesSection | undefined {
    return this.dataCard?.allergiesSection;
  }
  set allergiesSection(value: AllergiesSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'allergiesSection', value);
  }
  get chronicDiseasesSection(): ChronicDiseasesSection | undefined {
    return this.dataCard?.chronicDiseasesSection;
  }
  set chronicDiseasesSection(value: ChronicDiseasesSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'chronicDiseasesSection', value);
  }
  get medicineSection(): VersionedSection | undefined {
    return this.dataCard?.medicineSection;
  }
  set medicineSection(value: VersionedSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'medicineSection', value);
  }
  get mmrVaccinationSection(): VersionedSection | undefined {
    return this.dataCard?.mmrVaccinationSection;
  }
  set mmrVaccinationSection(value: VersionedSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'mmrVaccinationSection', value);
  }
  get tobaccoUseAndExposureSection(): TobaccoUseAndExposureSection | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection;
  }
  set tobaccoUseAndExposureSection(value: TobaccoUseAndExposureSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection', value);
  }
  get alcoholDrinkingBehaviorSection(): AlcoholDrinkingBehaviorSection | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection;
  }
  set alcoholDrinkingBehaviorSection(value: AlcoholDrinkingBehaviorSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection', value);
  }
  get substanceUseSection(): SubstanceUseSection | undefined {
    return this.dataCard?.substanceUseSection;
  }
  set substanceUseSection(value: SubstanceUseSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection', value);
  }
  get dietaryAndExerciseSection(): DietaryAndExerciseSection | undefined {
    return this.dataCard?.dietaryAndExerciseSection;
  }
  set dietaryAndExerciseSection(value: DietaryAndExerciseSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'dietaryAndExerciseSection', value);
  }
  get maternalRhDAntibodyScreeningSection(): MaternalRhDAntibodyScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.maternalRhDAntibody;
  }
  set maternalRhDAntibodyScreeningSection(value: MaternalRhDAntibodyScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.maternalRhDAntibody', value);
  }
  get maternalBloodSampleTaken(): YesNoEnum | undefined {
    return this.dataCard?.screeningsSection?.maternalRhDAntibody?.bloodSampleTaken;
  }
  set maternalBloodSampleTaken(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.maternalRhDAntibody.bloodSampleTaken', value);
  }
  get maternalRhesusType(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.maternalRhDAntibody?.rhesusType;
  }
  set maternalRhesusType(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.maternalRhDAntibody.rhesusType', value);
  }
  get maternalIrregularBGAntibodyPresent(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.maternalRhDAntibody?.irregularBloodGroupAntibodyPresent;
  }
  set maternalIrregularBGAntibodyPresent(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.maternalRhDAntibody.irregularBloodGroupAntibodyPresent', value);
  }
  get fetalRhDAntibodyScreeningSection(): FetalRhDAntibodyScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.fetalRhDAntibody;
  }
  set fetalRhDAntibodyScreeningSection(value: FetalRhDAntibodyScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.fetalRhDAntibody', value);
  }
  get fetalRhesusType(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.fetalRhDAntibody?.rhesusType;
  }
  set fetalRhesusType(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.fetalRhDAntibody.rhesusType', value);
  }
  get fetalAntiDIsoimmunizationAffectingPregnancy(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.fetalRhDAntibody?.antiDIsoimmunizationAffectingPregnancy;
  }
  set fetalAntiDIsoimmunizationAffectingPregnancy(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.fetalRhDAntibody.antiDIsoimmunizationAffectingPregnancy', value);
  }
  get antiDImmunoglobulinGivenSection(): YesNoDateScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.antiDImmunoglobulinGiven;
  }
  set antiDImmunoglobulinGivenSection(value: YesNoDateScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.antiDImmunoglobulinGiven', value);
  }
  get antiDImmunoglobulinGiven(): YesNoEnum | undefined {
    return this.dataCard?.screeningsSection?.antiDImmunoglobulinGiven?.value;
  }
  set antiDImmunoglobulinGiven(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.antiDImmunoglobulinGiven.value', value);
  }
  get antiDImmunoglobulinGivenDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.antiDImmunoglobulinGiven?.date;
  }
  set antiDImmunoglobulinGivenDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.antiDImmunoglobulinGiven.date', value);
  }
  get streptococcusGroupBSection(): PositiveNegativeScreeningWithDateSection | undefined {
    return this.dataCard?.screeningsSection?.streptococcusGroupB;
  }
  set streptococcusGroupBSection(value: PositiveNegativeScreeningWithDateSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.streptococcusGroupB', value);
  }
  get streptococcusGroupBResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.streptococcusGroupB?.result;
  }
  set streptococcusGroupBResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.streptococcusGroupB.result', value);
  }
  get streptococcusGroupBDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.streptococcusGroupB?.date;
  }
  set streptococcusGroupBDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.streptococcusGroupB.date', value);
  }
  get diabetesWeek18To20Section(): DateValueUnitScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.diabetesWeek18To20;
  }
  set diabetesWeek18To20Section(value: DateValueUnitScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesWeek18To20', value);
  }
  get diabetesWeek18To20Value(): number | undefined {
    return this.dataCard?.screeningsSection?.diabetesWeek18To20?.value;
  }
  set diabetesWeek18To20Value(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesWeek18To20.value', value);
  }
  get diabetesWeek18To20Date(): Date | undefined {
    return this.dataCard?.screeningsSection?.diabetesWeek18To20?.date;
  }
  set diabetesWeek18To20Date(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesWeek18To20.date', value);
  }
  get diabetesWeek28To30Section(): DateValueUnitScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.diabetesWeek28To30;
  }
  set diabetesWeek28To30Section(value: DateValueUnitScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesWeek28To30', value);
  }
  get diabetesWeek28To30Value(): number | undefined {
    return this.dataCard?.screeningsSection?.diabetesWeek28To30?.value;
  }
  set diabetesWeek28To30Value(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesWeek28To30.value', value);
  }
  get diabetesWeek28To30Date(): Date | undefined {
    return this.dataCard?.screeningsSection?.diabetesWeek28To30?.date;
  }
  set diabetesWeek28To30Date(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesWeek28To30.date', value);
  }
  get diabetesGlycosuriaSection(): DateValueUnitScreeningSection | undefined {
    return this.dataCard?.screeningsSection?.diabetesGlycosuria;
  }
  set diabetesGlycosuriaSection(value: DateValueUnitScreeningSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesGlycosuria', value);
  }
  get diabetesGlycosuriaValue(): number | undefined {
    return this.dataCard?.screeningsSection?.diabetesGlycosuria?.value;
  }
  set diabetesGlycosuriaValue(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesGlycosuria.value', value);
  }
  get diabetesGlycosuriaDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.diabetesGlycosuria?.date;
  }
  set diabetesGlycosuriaDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.diabetesGlycosuria.date', value);
  }
  get socialHistorySection(): SocialHistorySection | undefined {
    return this.dataCard?.socialHistorySection;
  }
  set socialHistorySection(value: SocialHistorySection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection', value);
  }
  get maritalOrPartnershipStatus(): MaritalOrPartnershipStatusEnum | undefined {
    return this.dataCard?.socialHistorySection?.maritalOrPartnershipStatus;
  }
  set maritalOrPartnershipStatus(value: MaritalOrPartnershipStatusEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.maritalOrPartnershipStatus', value);
  }
  get livingConditions(): LivingConditionsEnum | undefined {
    return this.dataCard?.socialHistorySection?.livingConditions;
  }
  set livingConditions(value: LivingConditionsEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.livingConditions', value);
  }
  get partnerName(): string | undefined {
    return this.dataCard?.socialHistorySection?.partner?.name;
  }
  set partnerName(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.partner.name', value);
  }
  get partnerCpr(): string | undefined {
    return this.dataCard?.socialHistorySection?.partner?.cpr;
  }
  set partnerCpr(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.partner.cpr', value);
  }
  get partnerNationality(): string | undefined {
    return this.dataCard?.socialHistorySection?.partner?.nationality;
  }
  set partnerNationality(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.partner.nationality', value);
  }
  get partnerNeedsTranslation(): YesNoEnum | undefined {
    return this.dataCard?.socialHistorySection?.partner?.needsTranslation;
  }
  set partnerNeedsTranslation(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.partner.needsTranslation', value);
  }
  get partnerTranslationLanguage(): string | undefined {
    return this.dataCard?.socialHistorySection?.partner?.translationLanguage;
  }
  set partnerTranslationLanguage(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.partner.translationLanguage', value);
  }
  get socialHistoryAddtionalInformations(): string | undefined {
    return this.dataCard?.socialHistorySection?.additionalInformations;
  }
  set socialHistoryAddtionalInformations(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'socialHistorySection.additionalInformations', value);
  }
  get patientCpr(): string | undefined {
    return this.dataCard?.recordTarget?.identifier;
  }
  set patientCpr(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'recordTarget.identifier', value);
  }
  get patientName(): PersonName | undefined {
    return this.dataCard?.personalDataSection?.name;
  }
  set patientName(value: PersonName | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.name', value);
  }
  get patientAddressStreetAndNumber(): string | undefined {
    return this.dataCard?.personalDataSection?.address?.streetAndNumber;
  }
  set patientAddressStreetAndNumber(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.address.streetAndNumber', value);
  }
  get patientAddressZip(): string | undefined {
    return this.dataCard?.personalDataSection?.address?.zip;
  }
  set patientAddressZip(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.address.zip', value);
  }
  get patientAddressCity(): string | undefined {
    return this.dataCard?.personalDataSection?.address?.city;
  }
  set patientAddressCity(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.address.city', value);
  }
  get patientTelecomsMobile(): string | undefined {
    return this.dataCard?.personalDataSection?.telecoms?.mobile;
  }
  set patientTelecomsMobile(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.telecoms.mobile', value);
  }
  get patientTelecomsWork(): string | undefined {
    return this.dataCard?.personalDataSection?.telecoms?.work;
  }
  set patientTelecomsWork(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.telecoms.work', value);
  }
  get patientTelecomsHome(): string | undefined {
    return this.dataCard?.personalDataSection?.telecoms?.home;
  }
  set patientTelecomsHome(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.telecoms.home', value);
  }
  get patientTemporaryAddress(): PersonalDataSectionAllOfTemporaryAddress | undefined {
    return this.dataCard?.personalDataSection?.temporaryAddress;
  }
  set patientTemporaryAddress(value: PersonalDataSectionAllOfTemporaryAddress | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.temporaryAddress', value);
  }
  get patientTemporaryAddressStreetAndNumber(): string | undefined {
    return this.dataCard?.personalDataSection?.temporaryAddress?.streetAndNumber;
  }
  set patientTemporaryAddressStreetAndNumber(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.temporaryAddress.streetAndNumber', value);
  }
  get patientTemporaryAddressZip(): string | undefined {
    return this.dataCard?.personalDataSection?.temporaryAddress?.zip;
  }
  set patientTemporaryAddressZip(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.temporaryAddress.zip', value);
  }
  get patientTemporaryAddressCity(): string | undefined {
    return this.dataCard?.personalDataSection?.temporaryAddress?.city;
  }
  set patientTemporaryAddressCity(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.temporaryAddress.city', value);
  }
  get patientTemporaryAddressValidFrom(): Date | undefined {
    return this.dataCard?.personalDataSection?.temporaryAddress?.validFrom;
  }
  set patientTemporaryAddressValidFrom(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.temporaryAddress.validFrom', value);
  }
  get patientTemporaryAddressValidTo(): Date | undefined {
    return this.dataCard?.personalDataSection?.temporaryAddress?.validTo;
  }
  set patientTemporaryAddressValidTo(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.temporaryAddress.validTo', value);
  }
  get generalPractitionerAddressStreetAndNumber(): string | undefined {
    return this.dataCard?.personalDataSection?.generalPractitioner?.address?.streetAndNumber;
  }
  set generalPractitionerAddressStreetAndNumber(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.generalPractitioner.address.streetAndNumber', value);
  }
  get generalPractitionerAddressZip(): string | undefined {
    return this.dataCard?.personalDataSection?.generalPractitioner?.address?.zip;
  }
  set generalPractitionerAddressZip(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.generalPractitioner.address.zip', value);
  }
  get generalPractitionerAddressCity(): string | undefined {
    return this.dataCard?.personalDataSection?.generalPractitioner?.address?.city;
  }
  set generalPractitionerAddressCity(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.generalPractitioner.address.city', value);
  }
  get patientNextOfKin(): PersonalDataSectionAllOfNextOfKin[] | undefined {
    return this.dataCard?.personalDataSection?.nextOfKin;
  }
  set patientNextOfKin(value: PersonalDataSectionAllOfNextOfKin[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.nextOfKin', value);
  }
  get healthcareSection(): HealthCareSection | undefined {
    return this.dataCard?.healthcareSection;
  }
  set healthcareSection(value: HealthCareSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'healthcareSection', value);
  }
  get healthcareWardName(): string | undefined {
    return this.dataCard?.healthcareSection?.ward?.name;
  }
  set healthcareWardName(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'healthcareSection.ward.name', value);
  }
  get healthcareNurseName(): string | undefined {
    return this.dataCard?.healthcareSection?.healthNurse?.name;
  }
  set healthcareNurseName(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'healthcareSection.healthNurse.name', value);
  }
  get healthcareNursePhone(): string | undefined {
    return this.dataCard?.healthcareSection?.healthNurse?.phone;
  }
  set healthcareNursePhone(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'healthcareSection.healthNurse.phone', value);
  }
}
